/*
 * Copyright (c) 1990 Regents of the University of Michigan.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that this notice is preserved and that due credit is given
 * to the University of Michigan at Ann Arbor. The name of the University
 * may not be used to endorse or promote products derived from this
 * software without specific prior written permission. This software
 * is provided ``as is'' without express or implied warranty.
 */

#include "dixie.h"
#include <stdio.h>
#include <quipu/ds_error.h>
#include <quipu/attrvalue.h>
#include <quipu/name.h>
#include <quipu/commonarg.h>
#include <quipu/bind.h>
#include <quipu/modify.h>
#include <quipu/read.h>
#include <ctype.h>

error( e )
struct DSError	*e;
{
	PS	ps;

        if ( (ps = ps_alloc( std_open )) == NULLPS ) {
                printf("error in ps_alloc");
                clean_exit(1);
        }
        if ( std_setup( ps, stderr ) == NOTOK ) {
                printf("error in std_setup = %d", ps->ps_errno);
                clean_exit(1);
        }

	ds_error( ps, e );

	ps_flush(ps);
	ps_free(ps);
}
