/*
 * Copyright (c) 1991 Regents of the University of Michigan.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that this notice is preserved and that due credit is given
 * to the University of Michigan at Ann Arbor. The name of the University
 * may not be used to endorse or promote products derived from this
 * software without specific prior written permission. This software
 * is provided ``as is'' without express or implied warranty.
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <dixie.h>
#include "ud.h"

struct entry Person;
char *duh;

parse_answer(s)
     char *s;
{
  duh = s;
}

print_person()
{
      register int i;
      register char *cp, *ep, *ap, **vp, **tp;
      char vals[20][MAX_VAL_SIZE],attrname[MAX_VAL_SIZE];
      char *tempfile;
      FILE *tmpfp;
      int foundphoto = 0, foundaudio = 0;
      
      for (ep = dxi_firstentry(duh); ep != NULL; ep = dxi_nextentry()) {
	    cp = strrchr(dxi_getdn(ep), '=');
	    cp++;
	    printf(" \"%s\"\n", cp);
	    for (ap = dxi_firstattr(ep); ap != NULL; ap = dxi_nextattr(ap)){
	       if ( !strcmp(ap,"objectClass") || !strcmp(ap,"source") || !strcmp(ap,"acl") || !strncmp(ap,"lastModified",12) || !strcmp(ap,"photo") || !strcmp(ap,"audio") )
		 continue;
	       vp = (char **) dxi_getvalues(ep, ap);
	       i = 0;
	       for (tp = vp; *tp != NULL; tp++) {
		 strcpy(vals[i],*tp);
		 i++;
	       }
	       strcpy(vals[i],"");
	       strcpy(attrname, ap);
	       if (!strcmp(attrname,"cn"))
		 strcpy(attrname,"commonName");
	       else if (!strcmp(attrname,"sn"))
		 strcpy(attrname,"surname");
	       else if (!strcmp(attrname,"uid"))
		 strcpy(attrname,"userid");
	       else if (!strcmp(attrname,"drink"))
		 strcpy(attrname,"favouriteDrink");
	       else if (!strcmp(attrname,"mobile"))
		 strcpy(attrname,"mobileTelephoneNumber");
	       else if (!strcmp(attrname,"pager"))
		 strcpy(attrname,"pagerTelephoneNumber");

	       if ( !strcmp(attrname,"secretary") || !strcmp(attrname,"seeAlso") ) {
		 int j;
		 for (j=0;j<i;j++) {
		   strcpy(vals[j],dxi_dn2ufn(vals[j]));
		 }
	       }
	       strcat(attrname,":");
	       while (strlen(attrname) < 20) {
		 if ( (20 - strlen(attrname)) > 5 )
		   strcat(attrname,"     ");
		 else
		   strcat(attrname," ");
	       }
	       print_entry(vals,attrname);
	       dxi_valuefree(vp);
	    }
      }
}

print_entry(s, label)
     char s[][MAX_VAL_SIZE], *label;
{
      char hex;
      register int i, j, k;
      register char c;
      int lead = strlen(label) + 2, isT61;
      
      printf("  %s", label);
      for (i = 0; s[i][0] != '\0'; i++) {
	    isT61 = 0;
	    if (i > 0) {
/*		  if (!strncmp(label, "Home a", 6) || !strncmp(label, "Postal a", 8) || !strncmp(label, "Campus Dom",10) ) {
			printf("  %s", label);
		  }
		  else {
*/
			for (k = lead; k > 0; k--)
			  putchar(' ');
/*		  } */
	    }
	    for (j = 0; s[i][j] != '\0'; j++) {
		  c = s[i][j];
		  switch (c) {
		      case '{' :
			if (!strncasecmp(&s[i][j], T61, strlen(T61))) {
			      isT61 = 1;
			      j += strlen(T61) - 1;
			}
			else
			  putchar(c);
			break;
		      case '\\' :
			if (isT61) {
			      c = s[i][++j];
			      /* 
			       * slight hack here . . .
			       *
			       * If 'c' is a newline, eat it,
			       * and continue as usual.
			       */
			      if (c == '\n')
				break;
			      if (isdigit(c))
				hex = c - '0';
			      else if (isupper(c))
				hex = c - 'A' + 10;
			      else
				hex = c - 'a' + 10;
			      hex <<= 4;
			      c = s[i][++j];
			      if (isdigit(c))
				hex += c - '0';
			      else if (isupper(c))
				hex += c - 'A' + 10;
			      else
				hex += c - 'a' + 10;
			}
			else
			  putchar(c);
			break;
		      case '$' :
			putchar('\n');
			for (k = lead; k > 0; k--)
			  putchar(' ');
			j++;
			break;
		      case '\n' :
			putchar('%');
			putchar('\n');
			break;
		      default:
			putchar(c);
		  }
	    }
	    putchar('\n');
      }
      return;
}

